/* 
A “dormitory” object can be defined so that a Java thread can “toSleep” in it 
until a wake-up event. Design and implement a Dormitory class with a given 
number of sleeping seats to be specified at construction time; provide it for 
the following methods:
toSleep(), to be called to toSleep in one of the available seats; in case no seat 
is available, it will block to access the dormitory in future sleeping turns;
trySleep(), to be called to toSleep in the current sleeping turn; in case no seat 
is available, it doesn’t block, returning a ‘false’ value, otherwise it 
succeeds and returns a ‘true’ value;
wakeUpAll() to wake up the current occupants and free their seats; in practice, 
a single sleeping turn is delimited by two successive invocations to 
wakeUpAll().

Design and implement the “Dormitory” class so that no thread may starve in 
invoking “toSleep”. Sketch also a test program to show how this synchronization 
mechanism can be actually used.
*/

package mySynchMeans;


public class MainSetting {
    
    public static final int NUMWORKERS = 1;
    public static final int NBEDS = 2;

    public static void main(String[] args) {
        
        Dormitory myDorm = new Dormitory(NBEDS);
        
        Thread[] wks = new Thread[NUMWORKERS];
        String[] names = {"Ciro   ","Mario  ","Antonio","Ugo    ","Paolo  ","Lapo   "};
        
        Thread   br = new BellRinger("Massimiliano***", myDorm);
        
        for(int i=0; i<NUMWORKERS; i++) {
            wks[i]=new TiredWorker(names[i%names.length]+"-"+Integer.toString(i), myDorm);
        }
        
        for(int i=0; i<NUMWORKERS; i++) {
            wks[i].start();
        }
        
        br.start();         
    }
}
