
package mySynchMeans;

public class TiredWorker extends Thread {
    
    private final Dormitory myDormitory;
    
    private static final int MINTIME=500;
    private static final int MAXTIME=1500;
    
    public TiredWorker(String name, Dormitory d) {
        myDormitory=d;
        this.setName(name);
    }
    
    @Override
    public void run() {
        
        while(true) {
            try {
                //working time
                int workingPeriod  = MINTIME + new java.util.Random().nextInt(MAXTIME-MINTIME);
                Thread.sleep(workingPeriod);
                
                if (workingPeriod %3 !=0) {
                    myDormitory.toSleep();
                }
                else {
                    myDormitory.trySleep();
                }
            }
            catch(InterruptedException ie) {
                System.out.println(ie.getMessage());
            }
        }
    }
}
